<!doctype html>
<html>
<head>
    <title>Tor 0.3.3.4-alpha is released! | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="Tor 0.3.3.4-alpha is released! | Tor Project">
    <meta property="og:description" content="There&#39;s a new alpha release available for download. If you build Tor from source, you can download the source code for 0.3.3.4-alpha from the usual place on the website. If you don&#39;t build Tor from source, don&#39;t worry! Updated packages should be available over the coming weeks, with a new alpha Tor Browser release some time in April.">
    <meta property="og:image" content="https://blog.torproject.org/static/images/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/tor-0334-alpha-released/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        Tor 0.3.3.4-alpha is released!
      </h1>
    <p class="meta">by nickm | March 29, 2018</p>
    <picture>
      <source media="(min-width:415px)" srcset="../static/images/lead.webp" type="image/webp">
<source srcset="../static/images/lead_small.webp" type="image/webp">

      <img class="lead" src="../static/images/lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>Hi! There's a new alpha release available for download. If you build Tor from source, you can download the source code for 0.3.3.4-alpha from the usual place on the website. If you don't build Tor from source, don't worry! Updated packages should be available over the coming weeks, with a new alpha Tor Browser release some time in April.</p>
<p>Tor 0.3.3.4-alpha includes various bugfixes for issues found during the alpha testing of earlier releases in its series. We are approaching a stable 0.3.3.4-alpha release: more testing is welcome!</p>
<h2>Changes in version 0.3.3.4-alpha - 2018-03-29</h2>
<ul>
<li>New system requirements:
<ul>
<li>When built with Rust, Tor now depends on version 0.2.39 of the libc crate. Closes tickets 25310 and 25664.</li>
</ul>
</li>
<li>Major bugfixes (relay, connection):
<ul>
<li>If we have failed to connect to a relay and received a connection refused, timeout, or similar error (at the TCP level), do not try that same address/port again for 60 seconds after the failure has occurred. Fixes bug <a href="https://bugs.torproject.org/24767">24767</a>; bugfix on 0.0.6.</li>
</ul>
</li>
</ul>
<p> </p>
<!--break--><ul>
<li>Minor features (geoip):
<ul>
<li>Update geoip and geoip6 to the March 8 2018 Maxmind GeoLite2 Country database. Closes ticket <a href="https://bugs.torproject.org/25469">25469</a>.</li>
</ul>
</li>
<li>Minor features (log messages):
<ul>
<li>Improve log message in the out-of-memory handler to include information about memory usage from the different compression backends. Closes ticket <a href="https://bugs.torproject.org/25372">25372</a>.</li>
</ul>
</li>
<li>Minor features (sandbox):
<ul>
<li>Explicitly permit the poll() system call when the Linux seccomp2-based sandbox is enabled: apparently, some versions of libc use poll() when calling getpwnam(). Closes ticket <a href="https://bugs.torproject.org/25313">25313</a>.</li>
</ul>
</li>
<li>Minor bugfixes (C correctness):
<ul>
<li>Fix a very unlikely (impossible, we believe) null pointer dereference. Fixes bug <a href="https://bugs.torproject.org/25629">25629</a>; bugfix on 0.2.9.15. Found by Coverity; this is CID 1430932.</li>
</ul>
</li>
<li>Minor bugfixes (channel, client):
<ul>
<li>Better identify client connection when reporting to the geoip client cache. Fixes bug <a href="https://bugs.torproject.org/24904">24904</a>; bugfix on 0.3.1.7.</li>
</ul>
</li>
<li>Minor bugfixes (compilation):
<ul>
<li>Fix a C99 compliance issue in our configuration script that caused compilation issues when compiling Tor with certain versions of xtools. Fixes bug <a href="https://bugs.torproject.org/25474">25474</a>; bugfix on 0.3.2.5-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (controller, reliability):
<ul>
<li>Avoid a (nonfatal) assertion failure when extending a one-hop circuit from the controller to become a multihop circuit. Fixes bug <a href="https://bugs.torproject.org/24903">24903</a>; bugfix on 0.2.5.2-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (networking):
<ul>
<li>Tor will no longer reject IPv6 address strings from TorBrowser when they are passed as hostnames in SOCKS5 requests. Fixes bug <a href="https://bugs.torproject.org/25036">25036</a>, bugfix on Tor 0.3.1.2.</li>
<li>string_is_valid_hostname() will not consider IP strings to be valid hostnames. Fixes bug <a href="https://bugs.torproject.org/25055">25055</a>; bugfix on Tor 0.2.5.5.</li>
</ul>
</li>
<li>Minor bugfixes (onion service v3):
<ul>
<li>Avoid an assertion failure when the next the next onion service descriptor rotation type is out of sync with the consensus's valid-after time. Instead, log a warning message with extra information, so we can better hunt down the cause of this assertion. Fixes bug <a href="https://bugs.torproject.org/25306">25306</a>; bugfix on 0.3.2.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (testing):
<ul>
<li>Avoid intermittent test failures due to a test that had relied on onion service introduction point creation finishing within 5 seconds of real clock time. Fixes bug <a href="https://bugs.torproject.org/25450">25450</a>; bugfix on 0.3.1.3-alpha.</li>
<li>Rust crates are now automatically detected and tested. Previously, some crates were not tested by `make test-rust` due to a static string in the `src/test/test_rust.sh` script specifying which crates to test. Fixes bug <a href="https://bugs.torproject.org/25560">25560</a>; bugfix on 0.3.3.3-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (testing, benchmarks):
<ul>
<li>Fix a crash when running benchmark tests on win32 systems. The crash was due to a mutex that wasn't initialized before logging and options were initialized. Fixes bug <a href="https://bugs.torproject.org/25479">25479</a>; bugfix on 0.3.3.3-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (warnings, ipv6):
<ul>
<li>Avoid a bug warning that could occur when trying to connect to a relay over IPv6. This warning would occur on a Tor instance that downloads router descriptors, but prefers to use microdescriptors. Fixes bug <a href="https://bugs.torproject.org/25213">25213</a>; bugfix on 0.3.3.1-alpha.</li>
</ul>
</li>
<li>Code simplification and refactoring:
<ul>
<li>Remove the old (deterministic) directory retry logic entirely: We've used exponential backoff exclusively for some time. Closes ticket <a href="https://bugs.torproject.org/23814">23814</a>.</li>
</ul>
</li>
<li>Documentation:
<ul>
<li>Improved the documentation of AccountingStart parameter. Closes ticket <a href="https://bugs.torproject.org/23635">23635</a>.</li>
<li>Update the documentation for "Log" to include the current list of logging domains. Closes ticket <a href="https://bugs.torproject.org/25378">25378</a>.</li>
</ul>
</li>
</ul>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/releases">
          releases
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-274669"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274669" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">March 30, 2018</p>
    </div>
    <a href="#comment-274669">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274669" class="permalink" rel="bookmark">Hi,
Long time no see! (oh,…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hi,</p>
<p>Long time no see! (oh, we've never met with each other...)</p>
<p>This time my irregular report is as follows.</p>
<ol>
<li>I was surprised that Tor network throughput had been improved a lot! Thank you so much.</li>
<li>I also found that this torproject website does not embed Web Beacon at all. You're gentle to us!</li>
<li>I have been getting used to using Linux distro little by little because I found a slightly better way than the previous one to study it...I already know how to surf, find, download and open a targeted file via Tor Browser in a simple and secure way unless I cannot find its URL.</li>
</ol>
<p>If I have any requests to you and there is no ticket to deal with them, I will create a ticket at Trac.<br />
Thank you again!</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-274674"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274674" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">March 30, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-274669" class="permalink" rel="bookmark">Hi,
Long time no see! (oh,…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-274674">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274674" class="permalink" rel="bookmark">I was surprised that Tor…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><blockquote><p>I was surprised that Tor network throughput had been improved a lot! Thank you so much.</p></blockquote>
<p>Many thanks to dgoulet for designing and implementing the DDoS protection which helped a lot and even scared the DDoSers into pausing their DDoS.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-274788"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274788" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">April 04, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-274674" class="permalink" rel="bookmark">I was surprised that Tor…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-274788">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274788" class="permalink" rel="bookmark">Thank you so much dgoulet, I…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Thank you so much dgoulet, I like torsocks command too since it's easy and secure to use!</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-274675"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274675" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>anon (not verified)</span> said:</p>
      <p class="date-time">March 30, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-274669" class="permalink" rel="bookmark">Hi,
Long time no see! (oh,…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-274675">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274675" class="permalink" rel="bookmark">There has also been a large…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>There has also been a large improvement in download times for .onion's shown here.<br />
<a href="https://metrics.torproject.org/torperf.html?start=2017-12-30&amp;end=2018-03-30&amp;source=all&amp;server=onion&amp;filesize=50kb" rel="nofollow">https://metrics.torproject.org/torperf.html?start=2017-12-30&amp;end=2018-0…</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-274746"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274746" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>anon (not verified)</span> said:</p>
      <p class="date-time">April 03, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-274675" class="permalink" rel="bookmark">There has also been a large…</a> by <span>anon (not verified)</span></p>
    <a href="#comment-274746">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274746" class="permalink" rel="bookmark">Not really, it simply…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Not really, it simply returned to the normal before the attack has been launched since November. But it shows the DDoS mitigation is effective, well done!</p>
<p><a href="https://metrics.torproject.org/torperf.html?start=2017-01-30&amp;end=2018-03-30&amp;source=all&amp;server=onion&amp;filesize=50kb" rel="nofollow">https://metrics.torproject.org/torperf.html?start=2017-01-30&amp;end=2018-0…</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div><a id="comment-274690"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274690" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>all sites block tor (not verified)</span> said:</p>
      <p class="date-time">March 31, 2018</p>
    </div>
    <a href="#comment-274690">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274690" class="permalink" rel="bookmark">Access Denied
You don&#039;t have…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Access Denied<br />
You don't have permission to access "<a href="http://www.target.com/" rel="nofollow">http://www.target.com/</a>" on this server.</p>
<p>Reference #18.6a94dc17.1522549133.dcd4eea</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-274704"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274704" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>jose (not verified)</span> said:</p>
      <p class="date-time">April 01, 2018</p>
    </div>
    <a href="#comment-274704">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274704" class="permalink" rel="bookmark">just of late my tor browser…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>just of late my tor browser opens to show<br />
<a href="https://www.duckduckgo.com/?ia=web" rel="nofollow">https://www.duckduckgo.com/?ia=web</a><br />
what does this mean.. the /?ia=web is not a problem in other browsers yet..<br />
is this a ubuntu thing or a tor browswer thing</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-274785"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274785" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  gk
  </article>
    <div class="comment-header">
      <p class="comment__submitted">gk said:</p>
      <p class="date-time">April 04, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-274704" class="permalink" rel="bookmark">just of late my tor browser…</a> by <span>jose (not verified)</span></p>
    <a href="#comment-274785">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274785" class="permalink" rel="bookmark">Hard to say. How did you…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hard to say. How did you modify your Tor Browser? Does this happen with a clean, new one downloaded from our website as well?</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-274705"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274705" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">April 01, 2018</p>
    </div>
    <a href="#comment-274705">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274705" class="permalink" rel="bookmark">If the two recent TAILS…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>If the two recent TAILS updates are so important, why aren't they posting updates news here?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-274763"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274763" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Cyber_st (not verified)</span> said:</p>
      <p class="date-time">April 03, 2018</p>
    </div>
    <a href="#comment-274763">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274763" class="permalink" rel="bookmark">Hello, thanks for all the…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hello, thanks for all the good work! But in the future could you think about releasing a Arm version of TOR browser? It would help a lot all the RPi users around the world!!! Anyways, thanks for the good work!!!</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-274784"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274784" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  gk
  </article>
    <div class="comment-header">
      <p class="comment__submitted">gk said:</p>
      <p class="date-time">April 04, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-274763" class="permalink" rel="bookmark">Hello, thanks for all the…</a> by <span>Cyber_st (not verified)</span></p>
    <a href="#comment-274784">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274784" class="permalink" rel="bookmark">We don&#039;t have the capacity…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>We don't have the capacity to do so right now, please help! The ticket for that is: <a href="https://trac.torproject.org/projects/tor/ticket/12631" rel="nofollow">https://trac.torproject.org/projects/tor/ticket/12631</a>.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-274768"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274768" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">April 03, 2018</p>
    </div>
    <a href="#comment-274768">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274768" class="permalink" rel="bookmark">Sooooo... when will…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Sooooo... when will TorProject be opening up to crypto donations? Or should we start our own tor  fork?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-274853"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274853" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">April 08, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-274768" class="permalink" rel="bookmark">Sooooo... when will…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-274853">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274853" class="permalink" rel="bookmark">They don&#039;t allow those kinds…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>They don't allow those kinds of donations already? And I'm not sure what forking Tor would accomplish.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-274848"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274848" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Windie (not verified)</span> said:</p>
      <p class="date-time">April 08, 2018</p>
    </div>
    <a href="#comment-274848">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274848" class="permalink" rel="bookmark">Hi, I was wondering why I…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hi, I was wondering why I can't log in to Twitter on Tor.  How can I log into my Twitter account?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-274872"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274872" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">April 10, 2018</p>
    </div>
    <a href="#comment-274872">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274872" class="permalink" rel="bookmark">Hi nickm,
I have a few…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hi nickm,</p>
<p>I have a few questions to you because you are probably responsible for me.</p>
<ol>
If I create a new online account to have a direct communication channel with you with my real name, may I send a message to you?<br />
I am interested in Mozilla Fellowship job. Do you think I am talented for this job?
</ol>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
